var fs = require('fs');
var fontkit = require('fontkit');

// open a font synchronously
var font = fontkit.openSync(__dirname + '/font-awesome/fonts/s-fontawesome webfont.otf');

// layout a string, using default shaping features.
// returns a GlyphRun, describing glyphs and positions.
var run = font.layout('\uf293');

// create a font subset
var subset = font.createSubset();
run.glyphs.forEach(function(glyph) {
  subset.includeGlyph(glyph);
});

subset.name = font.name;
subset.encodeStream()
      .pipe(fs.createWriteStream(__dirname + '/font-awesome/fonts/fontawesome webfont.otf'));


